#include <Ping.h>

Ping pingLeft = Ping(4);
Ping pingCenter = Ping(3);
Ping pingRight = Ping(2);

float irLeft, irCenter, irRight;
  
void SendIRDataText()
{
  Serial.print((byte)irLeft, DEC);
  Serial.print(",");
  Serial.print((byte)irCenter, DEC);
  Serial.print(",");
  Serial.print((byte)irRight, DEC);
  Serial.println();
}

void SendIRDataBinary()
{
  Serial.write(byte(irLeft));
  Serial.write(byte(irCenter));
  Serial.write(byte(irRight));
}

void ReadIRSensors()
{
  irRight = ReadGP2D12(0);
  irLeft = ReadGP2D12(1);
  irCenter = ReadGP2D12(2);
}

float ReadGP2D12(byte pin)
{
  int temp = analogRead(pin);
  float temp2 = (6787.0 / ((float)temp - 3.0)) - 4.0;
  float temp3 = max(min(temp2, 81), 0);
  if(temp3 == 81)
    return 0;
  else
    return temp3;
}

void setup()
{
  Serial.begin(19200);
}

void loop()
{
  int incomingByte = 0;
  if (Serial.available() > 0)
  {
    incomingByte = Serial.read();
    switch(incomingByte)
    {
      case 'A':
        ReadIRSensors();
        SendIRDataText();
        break;
        
      case 'B':
        ReadIRSensors();
        SendIRDataBinary();
        break;
        
      case '1':
        irLeft = ReadGP2D12(1);
        Serial.println((byte)irLeft, DEC);
        break;
        
      case '2':
        irCenter = ReadGP2D12(2);
        Serial.println((byte)irCenter, DEC);
        break;
        
      case '3':
        Serial.println((byte)irRight, DEC);
        irRight = ReadGP2D12(0);
        break;
        
      case '4':
        pingLeft.fire();
        Serial.println((byte)pingLeft.centimeters(), DEC);
        break;
        
      case '5':
        Serial.println(255, DEC);
        break;
        
      case '6':
        pingRight.fire();
        Serial.println((byte)pingRight.centimeters(), DEC);
        break;
        
      case 'a':
        irLeft = ReadGP2D12(1);
        Serial.write((byte)irLeft);
        break;
        
      case 'b':
        irCenter = ReadGP2D12(2);
        Serial.write((byte)irCenter);
        break;
        
      case 'c':
        irRight = ReadGP2D12(0);
        Serial.write((byte)irRight);
        break;
        
      case 'd':
        pingLeft.fire();
        if(pingLeft.centimeters() > 255)
          Serial.write(255);
        else
          Serial.write((byte)pingLeft.centimeters());
        break;
        
      case 'e':
        Serial.write(255);
        break;
        
      case 'f':
        pingRight.fire();
        if(pingRight.centimeters() > 255)
          Serial.write(255);
        else
        Serial.write((byte)pingRight.centimeters());
        break;
    }
  }
}


