﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Media;
using System.Windows.Threading;
using EyeControl;

namespace EyeDemo
{
  /// <summary>
  /// Interaction logic for MainWindow.xaml
  /// </summary>
  public partial class MainWindow
  {

    public MainWindow()
    {
      InitializeComponent();
      ball1.Moving = true;
      ball1.BallMoved += TimerTick;
    }

    private void TimerTick(object sender, EventArgs e)
    {
      foreach (DependencyObject dependencyObject in GetChildren<Eye>(this))
        if (dependencyObject is Eye)
          ((Eye)dependencyObject).FocusPoint = ball1.Center();
    }

    private static IEnumerable<DependencyObject> GetChildren<T>(DependencyObject dependencyObject)
   {   
     for (var i = 0; i < VisualTreeHelper.GetChildrenCount(dependencyObject); i++)
     {
       DependencyObject visual = VisualTreeHelper.GetChild(dependencyObject, i);
       if (visual is T)
         yield return visual;
       if (VisualTreeHelper.GetChildrenCount(visual) > 0)
       {
         foreach (DependencyObject child in GetChildren<T>(visual))
           yield return child;

       }
     }
   }

  }
}